/*
    Fichier comptemail.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme affiche le nombre de mail en attente de tlchargement
    (ou de destruction).

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"


/* programme principal */

int main (int nbarg, char *varg[])
{
    FILE *fconf;        // descripteur du fichier de configuration
    int  nb_mails;      // nombre de mails
    int  optn;          // option d'affichage


    // rcupration du nom de l'excutable
    memcom (*varg);

    // si option -n (affichage du nombre de mails seulement)
    if (--nbarg >= 1 && strcmp (varg [1], "-n") == 0)
    {
        // la mmoriser
        optn = 1;

        // et passer  l'argument suivant
        varg ++;
        nbarg --;
    }
    else
        // sinon, pas d'option -n
        optn = 0;

    if (nbarg == 1)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (varg [1]);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcupration du nombre de mails
                nb_mails = nbmails ();

                // affichage du nombre de mails
                if (optn)
                    printf ("%d\n", nb_mails);
                else
                {
                    if (nb_mails > 1)
                        // "%d mails dans %s\n"
                        printf (message ("COMPTE_MAILS"), nb_mails, varg [1]);
                    else if (nb_mails == 1)
                        // "1 mail dans %s\n"
                        printf (message ("UN_SEUL_MAIL"), varg [1]);
                    else
                        // "Aucun mail dans %s\n"
                        printf (message ("AUCUN_MAIL"), varg [1]);
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s [-n] fichier_configuration"
        psyntaxe ("SYNT_COMPTEMAIL");

    return (0);
}
