/*
    Fichier deplpartiel.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme dplace vers une autre boite aux lettres parmi
    les mail en attente sur le serveur de messagerie, ceux dont
    l'un des champs contient (ou ne contient pas) une chaine de
    caractres particulire.

    Une option permet de conserver les mails slectionns dans la
    boite aux lettres initiale. Dans ce cas, les mails slectionns
    sont seulement copis.

    Un fichier de configuration est utilis pour se connecter 
    la boite aux lettres, pour connaitre l'adresse d'expdition
    et pour slectionner le serveur SMTP servant  la rexpdition
    des mails.
    Il s'agit d'une variante des fichiers de configuration utiliss
    par la plupart des autres outils de libremail.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"
#include "smtp.h"
#include "trtentete.h"
#include "copiedepl.h"


/* prototype */
int  testchamp (char *nomchamp, char *chainetest, int numes);


/* programme principal */

int main (int nbarg, char *varg[])
{
    char serv_smtp [120]; // nom du serveur smtp utilis
    FILE *fconf;         // descripteur du fichier de configuration
    long nbmes;          // nombre de mails sur le serveur
    long numail;         // numro du mail  dplacer ou copier
    long nbtraites;      // rcapitulatif nombre de mails copis ou dplacs
    int  optc;           // option : on conserve les mails dplacs
    int  optn;           // option : mail dplac si valchamp n'est pas trouv
                         //          dans le champ nomchamp ou si champ absent
    char *nomchamp;      // nom du champ sur lequel porte la slection des mails
    char *valchamp;      // valeur de nomchamp pour que le mail soit slectionn

    // message signalant la copie ou le dplacement d'un mail
    char mess_copdepl [50];


    // rcupration du nom de l'excutable
    memcom (*varg);

    // se positionner sur le premier argument de deplpartiel
    varg ++;
    nbarg --;

    // options de fonctionnement par dfaut
    optc = 0;
    optn = 0;

    // rcupration des options de fonctionnement ventuelles
    while (nbarg > 0 && **varg == '-')
    {
        switch (varg [0][1])
        {
            // option copie des mails plutt que dplacement
            case 'c': optc = 1;
                      break;

            // option dplacement du mail si chaine non trouve
            case 'n': optn = 1;
                      break;

                      // "Option %s incorrecte"
            default : aff_err_arg ("ERR_OPTION", *varg);
                      nbarg = 0;   // pour afficher la syntaxe de la commande
        }

        // dcompter l'argument trait
        varg ++;
        nbarg --;
    }

    // rcupration du nom de champ et de sa valeur
    if (nbarg >= 3)
    {
        // rcuprer nomchamp et valchamp
        nomchamp = *varg;
        valchamp = varg [1];

        // dcompter les arguments traits
        varg  = varg  + 2;
    }

    // la prsence du nom de champ et de sa valeur tait obligatoire
    nbarg = nbarg - 2;

    // on autorise la prsence de l'option -c aprs -n nom_champ chaine_champ
    if (nbarg > 0 && strcmp (*varg, "-c") == 0)
    {
        // mmoriser l'option
        optc = 1;

        // dcompter l'argument trait
        varg ++;
        nbarg --;
    }

    // controle du nombre d'arguments restant
    if (nbarg == 1)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (*varg);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcuprer et mmoriser les adresses
                // Email d'expdition et de destination
                mem_adr (adr_exped, fconf);
                mem_adr (adr_dest, fconf);

                // rcupration du nombre de mails
                nbmes = nbmails ();

                // si des mails peuvent tre traits
                if (nbmes)
                {
                    // recuprer le nom du serveur smtp
                    fgets (serv_smtp, 120, fconf);
                    serv_smtp [strlen (serv_smtp) - 1] = '\0';

                    // connexion au serveur smtp pour l'envoi des mails
                    if (connect_smtp (serv_smtp))
                    {
                        // initialisation
                        nbtraites = 0;

                        // mmorisation message adapt au traitement des mails
                        if (optc)
                            strcpy (mess_copdepl, message ("COPIE_MAIL"));
                        else
                            strcpy (mess_copdepl, message ("DEPL_MAIL"));

                        // pour chaque mail du serveur
                        for (numail = 1; numail <= nbmes; numail++)
                        {
                            // si le champ  tester contient la chaine
                            // (ou ne la contient pas si option -n)
                            if (testchamp (nomchamp, valchamp, numail) != optn)
                            {
                                // message indiquant copie ou dplacement mail
                                printf (mess_copdepl, numail);
                                fflush (stdout);

                                // envoyer une copie du mail  l'autre adresse
                                copiemail (numail);

                                // si dplacement des mails
                                if (! optc)
                                    // supprimer le mail du premier serveur
                                    detruitmail (numail);

                                // on compte les mails copis ou dplacs
                                nbtraites ++;
                            }
                        }

                        // dition d'un rcapitulatif adapt
                        if (optc)
                            // "\n%d mails copis sur %d\n"
                            printf (message ("TOTAL_COPIES"), nbtraites, nbmes);
                        else
                            // "\n%d mails dplacs sur %d\n"
                          printf (message ("TOTAL_DEPLACES"), nbtraites, nbmes);

                        // pour l'affichage
                        putchar ('\n');

                        // fermeture de la connexion smtp
                        deconnect_smtp ();
                    }
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s [-c] [-n] nom_champ chaine_champ fichier_configuration"
        psyntaxe ("SYNT_DEPLPARTIEL");

    // pour faire plaisir  gcc qui veut une fonction main de type int
    return (0);
}


/* vrifie si le champ nomchamp du mail de numro numes
   contient la chaine passe en 2me paramtre */

int testchamp (char *nomchamp, char *chainetest, int numes)
{
    char bufw [120];     // buffer d'envoi d'une requte
    char valchamp [120]; // contenu du champ  tester
    int  poschamp;       // positionnement dans valchamp
    int  i;              // positionnement dans chainetest


    // initialisation
    valchamp [0] = '\0';

    // message de suivi de droulement
    // "\rAnalyse du mail n %d       "
    printf (message ("ANALYSE_MAIL_BL"), numes);
    fflush (stdout);

    // demande de lecture de l'entte du message
    sprintf (bufw, "TOP %d 1", numes);
    env_pop (bufw);

    // lire la premire ligne de l'entte du message
    lire_pop ();

    // termin pour ce mail si erreur d'envoi cot serveur
    if (memcmp (buf_lect, "-ERR ", 5) == 0)
    {
        // Erreur serveur pour l'accs au mail
        aff_err_argnum ("ERREUR_SERVEUR", numes);
        return 0;
    }

    // lecture et mmorisation des caractristiques du message
    do
    {
        // si elle contient le champ recherch
        if (start (nomchamp))
        {
            // convertir les caractres spciaux
            majlignentete ();

            // et mmoriser ce champ
            membuf (valchamp);
        }

        // lire la ligne suivante de l'entte du message
        lire_pop ();
    }
    // lecture termine si ligne limite  un .
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');

    // on se positionne au dbut du champ  tester
    poschamp = 0;

    // vrifier si la chaine chainetest se trouve dans valchamp
    do
    {
        i = 0;

        while (valchamp [poschamp+i] == chainetest [i])
        {
            // termin si tous les caractres de chainetest trouvs
            if (chainetest [++i] == 0)
                return 1;
        }
    }
    // sinon recherche dans la suite de valchamp
    while (valchamp [poschamp++]);

    // aucune des chaines de la liste n'a t trouve dans valchamp
    return (0);
}
