/*
    Fichier listemail.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme affiche le numro d'ordre et la taille de chaque
    mail en attente de tlchargement (ou de destruction).

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"


/* prototypes */
void lister (char *ficdest);


/* programme principal */

int main (int nbarg, char *varg[])
{
    FILE *fconf;        // descripteur du fichier de configuration
    int  numes, nbmes;  // numro du mail courant et nombre de mails


    // rcupration du nom de l'excutable
    memcom (*varg);

    if (--nbarg == 1 || nbarg == 2)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (varg [1]);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcupration de la liste des mails
                if (nbarg == 2)
                    lister (varg [2]);
                else
                    lister (0);

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s fichier_configuration [fichier_sortie]"
        psyntaxe ("SYNT_LISTEMAIL");

    return (0);
}


/* listage des messages
   le rsultat va :
   - soit dans le fichier du nom pass en paramtre
   - soit dans stdout si paramtre  0
*/

void lister (char *ficdest)
{
    FILE *fdest;  // descripteur du fichier rsultat


    // ouvrir le fichier qui mmorisera les rsultats
    if (ficdest)
    {
        fdest = fopen (ficdest, "w");

        if (fdest == 0)
        {
            // "Impossible d'crire dans le fichier %s"
            aff_err_arg ("IMPOS_ECR_FICH", ficdest);
            return;
        }
    }
    else
        fdest = stdout;

    // demande de la liste des mails
    env_pop ("LIST");

    // lecture et affichage ou mmorisation de la rponse
    do
    {
        lire_pop ();
        fprintf (fdest, "%s\n", buf_lect);
    }
    while (buf_lect [0] != '.');

    // librer si ncessaire le fichier rsultat
    if (ficdest)
        fclose (fdest);
}
