/*
    Fichier listesimexped.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme liste les mails du serveur dont le nom de l'expditeur
    indiqu diffre d'un petit nombre de caractres d'un nom d'expditeur
    figurant dans une liste.

    La liste des noms d'expditeurs  tester est mmorise dans un
    fichier.

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"
#include "testchamp.h"
#include "simexped.h"
#include "szchemin.h"


/* variables globales au source
   (pour viter des tonnes de passages de paramtres) */

char **listexped;      // mmorise les noms d'expditeurs  tester
int  sz_listexped;     // nombre d'expditeurs mmoriss dans listexped


/* programme principal */

int main (int nbarg, char *varg[])
{
    // fichier contenant la liste des chaines  tester
    char fichliste [szchemin + 12];
    char *car_fichliste; // pointeur sur un caractre de ce fichier
    FILE *fconf;         // descripteur du fichier de configuration
    int  numes, nbmes;   // mumro du mail courant et nombre de mails
    int  nbdiff;         // nombre de diffrences dans le nom d'expditeur
    int  nbmaxdiff;      // nombre max de diffrences dans le nom d'expditeur
    char bufFrom [120];  // buffer contenant l'expditeur du mail


    // rcupration du nom de l'excutable
    memcom (*varg);

    // se positionner sur le premier argument de listesimexped
    nbarg --;
    varg ++;

    // si nombre de diffrence maximal pass en paramtre
    if (nbarg == 2 && atoi (*varg) > 0)
    {
        // rcuprer ce nombre
        nbmaxdiff = atoi (*varg);

        // sauter l'argument trait
        nbarg --;
        varg ++;
    }
    // sinon
    else
        // une seule diffrence par dfaut
        nbmaxdiff = 1;

    // contrle du nombre d'arguments restants
    if (nbarg == 1)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (*varg);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcuprer le nom du rpertoire racine de la messagerie
                fgets (fichliste, szchemin, fconf);

                // fabriquer le chemin d'accs au fichier contenant les
                // noms d'expditeurs  tester : <racine>/simexped
                car_fichliste = fichliste + strlen (fichliste);
                *(car_fichliste - 1) = '/';
                strcpy (car_fichliste, ficdir ("FIC_SIMEXPED"));

                // charger en mmoire les noms d'expditeurs  tester
                listexped = charge_valchamp (fichliste, &sz_listexped);

                // si la liste n'est pas vide
                if (sz_listexped)
                {
                    // rcupration du nombre de mails
                    nbmes = nbmails ();

                    // vrification des diffrents mails
                    for (numes = 1; numes <= nbmes; numes++)
                    {
                        // recuprer l'expditeur du mail
                        recup_exped (numes, bufFrom);

                        // compter les diffrences par rapport
                        // au nom d'expditeur le plus proche
                        nbdiff = simexped (bufFrom, listexped, sz_listexped);

                        // s'il y a des diffrences, mais pas trop
                        if (nbdiff && nbdiff <= nbmaxdiff)
                            // afficher le nombre de diffrences et l'expditeur
                            printf ("%d %s\n", nbdiff, bufFrom);
                    }
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s [nbmaxdiff] fich_configuration"
        psyntaxe ("SYNT_LISTESIMEXP");

    return (0);
}
