/*
    Fichier simexped.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Bibliothque de fonctions permettant de rcuprer le nom
    d'expditeur d'un mail, puis de le comparer  des noms
    d'expditeurs d'une liste pour compter les diffrences.
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "buflect.h"
#include "messages.h"
#include "pop.h"
#include "simexped.h"
#include "trtentete.h"


// lit l'entte d'un mail et rcupre le champ expditeur

void recup_exped (int numes, char *bufFrom)
{
    char bufw [120]; // buffer d'envoi d'une requte
    int  debexped;   // position du premier caractre significatif du exped


    // initialisations
    bufFrom [0] = '\0';

    // demande de lecture de l'entte du message
    sprintf (bufw, "TOP %d 1", numes);
    env_pop (bufw);

    // lire la premire ligne de l'entte du message
    lire_pop ();

    // termin pour ce mail si erreur d'envoi cot serveur
    if (memcmp (buf_lect, "-ERR ", 5) == 0)
    {
        // Erreur serveur pour l'accs au mail
        aff_err_argnum ("ERREUR_SERVEUR", numes);
        return;
    }

    // lecture entte du message et mmorisation de l'expditeur du mail
    do
    {
        // si on a trouv le champ exped
        if (start ("From"))
        {
            // recherche du premier caractre significatif du exped
            debexped = 6;

            while (buf_lect [debexped] == ' ')
                debexped++;

            // tronquer si ncessaire l'expditeur
            if (strlen (buf_lect + debexped) >= 120)
                 buf_lect [debexped + 120] = '\0';

            // mmorisation de l'expditeur
            strcpy (bufFrom, buf_lect + debexped);
        }

        // lire la ligne suivante de l'entte du message
        lire_pop ();
    }
    // lecture termine si ligne limite  un .
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');
}



/* recherche si le champ du mail passe en paramtre
   contient l'une des chaines de la liste */

int simexped (char *bufFrom, char **liste, int sz_liste)
{
    char exped [120]; // expditeur  tester
    char *chainetest; // chaine de la liste  tester
    int  nbdiff;      // nombre de diffrences
    int  mindiff;     // nombre de diffrences pour la chaine qui en a le moins
    int  i, j;        // compteurs


    // initialisation
    i = 0;

    // mmorisation de l'expditeur

    // s'il commence par "
    if (*bufFrom == '"')
    {
        // on mmorise ce qu'il y a entre les deux "
        while (bufFrom [i + 1] != '"' && bufFrom [i + 1])
        {
            exped [i] = bufFrom [i + 1];
            i++;
        }

        // terminer la chaine de caractres
        exped [i] = '\0';
    }
    // sinon
    else
    {
        // chercher aprs le premier espace
        while (bufFrom [i] && bufFrom [i++] != ' ')
            ;
        // le champ adresse de l'expditeur
        while (bufFrom [i] && bufFrom [i++] != '@')
            ;

        // le nom de l'expditeur est jusqu' l'espace qui prcde
        while (i > 0 && bufFrom [i] != ' ')
            i--;

        // prcaution pour le cas oil y aurait plusieurs espaces
        while (i > 0 && bufFrom [i] == ' ')
            i--;

        // on mmorise l'expditeur en commenant par la fin
        exped [i] = '\0';

        while (i--)
            exped [i] = bufFrom [i];
    }

    // initialisation
    mindiff = strlen (exped);

    // on compare la chaine exped avec toutes les chaines de la liste
    // sauf si on a trouv la chaine exped telle quelle dans la liste
    for (j = 0; j < sz_liste && mindiff; j++)
    {
        // on ne compare que des chaines de longueur identique
        if (strlen (exped) == strlen (liste [j]))
        {
            // slectionner la chaine  comparer
            chainetest = liste [j];

            // initialisation
            i = 0;
            nbdiff = 0;

            // tant que la chaine expditeur n'a pas t parcourue
            while (exped [i])
            {
                // comparer 2 caractres  la mme position
                // on accepte les diffrences de casse (par scurit)
                if (tolower (exped [i]) != tolower (chainetest [i]))
                    // comptabiliser les diffrences
                    nbdiff ++;

                // passer au caractre suivant des 2 chaines
                i++;
            }

            // si moins de diffrences que pour une chaine prcdente
            if (mindiff > nbdiff)
                // mmoriser la nouvelle valeur de nbdiff
                mindiff = nbdiff;
        }
    }

    // retourner le rsultat de la meilleure comparaisons
    return (mindiff);
}
