/*
    Fichier listesimexped.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme dtruit les mail du serveur dont le nom de l'expditeur
    indiqu diffre d'un petit nombre de caractres d'un nom d'expditeur
    figurant dans une liste.

    La liste des noms d'expditeurs  tester est mmorise dans un
    fichier.

    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"
#include "testchamp.h"
#include "datecour.h"
#include "simexped.h"
#include "szchemin.h"


/* variables globales au source
   (pour viter des tonnes de passages de paramtres) */

char **listexped;      // mmorise les noms d'expditeurs  tester
int  sz_listexped;     // nombre d'expditeurs mmoriss dans listexped

// chaine de caractre mmorise pour viter appels rptitifs  message ()
char mess_analys [50]; // message signalant l'analyse d'un mail


/* programme principal */

int main (int nbarg, char *varg[])
{
    // fichier contenant la liste des chaines  tester
    char fichliste [szchemin + 12];
    char *car_fichliste; // pointeur sur un caractre de ce fichier
    FILE *fconf;         // descripteur du fichier de configuration
    FILE *ftrace;        // fichier contenant les expditeurs des mail refuss
    int  numes, nbmes;   // mumro du mail courant et nombre de mails
    int  nbdiff;         // nombre de diffrences dans le nom d'expditeur
    int  nbmaxdiff;      // nombre max de diffrences dans le nom d'expditeur
    char bufFrom [120];  // buffer contenant l'expditeur du mail
    char bufw [120];     // buffer d'envoi d'une requte de destruction de mail
    char datecour [10];  // date courante (pour le fichier des mails refuss)
    int  conserves = 0;  // nombre de mails conservs
    int  supprimes = 0;  // nombre de mails supprims


    // rcupration du nom de l'excutable
    memcom (*varg);

    // se positionner sur le premier argument de listesimexped
    nbarg --;
    varg ++;

    // initialisation des valeurs des options
    nbmaxdiff = 1;   // une seule diffrence par dfaut
    ftrace = NULL;   // pas de fichier trace

    // tant qu'il peut y avoir des options  traiter
    while (nbarg > 1)
    {
        // si nombre de diffrence maximal pass en paramtre
        if (atoi (*varg) > 0)
        {
            // rcuprer ce nombre
            nbmaxdiff = atoi (*varg);

            // sauter l'argument trait
            nbarg --;
            varg ++;
        }
        // sinon si option -t (trace des mails supprims)
        else if (**varg == '-' && varg [0][1] == 't')
        {
            // ouvrir le fichier trace en criture fin de fichier
            ftrace = fopen (varg [1], "a");

            // si nom de fichier correct
            if (ftrace)
                // initialiser la date courante
                initdatecour (datecour);
            else
                // sinon, avertir l'utilisateur
                // "Impossible d'crire dans le fichier %s"
                aff_err_arg ("IMPOS_ECR_FICH", varg [1]);

            // sauter les arguments traits
            nbarg -= 2;
            varg  += 2;
        }
        // aucune autre option n'est reconnue
        else
        {
            // "Option %s incorrecte"
            aff_err_arg ("ERR_OPTION", *varg);
            nbarg = 0;  // pour rappeller la syntaxe
        }
    }

    // contrle du nombre d'arguments restants
    if (nbarg == 1)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (*varg);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcuprer le nom du rpertoire racine de la messagerie
                fgets (fichliste, szchemin, fconf);

                // fabriquer le chemin d'accs au fichier contenant les
                // noms d'expditeurs  tester : <racine>/simexped
                car_fichliste = fichliste + strlen (fichliste);
                *(car_fichliste - 1) = '/';
                strcpy (car_fichliste, ficdir ("FIC_SIMEXPED"));

                // charger en mmoire les noms d'expditeurs  tester
                listexped = charge_valchamp (fichliste, &sz_listexped);

                // si la liste n'est pas vide
                if (sz_listexped)
                {
                    // rcupration du nombre de mails
                    nbmes = nbmails ();

                    // Initialisation du message  afficher  chaque
                    // analyse de mail  "\rAnalyse du mail n %d"
                    strcpy (mess_analys, message ("ANALYSE_MAIL"));

                    // vrification des diffrents mails
                    for (numes = 1; numes <= nbmes; numes++)
                    {
                        // "\rAnalyse du mail n %d"
                        printf (mess_analys, numes);
                        fflush (stdout);

                        // recuprer l'expditeur du mail
                        recup_exped (numes, bufFrom);

                        // compter les diffrences par rapport
                        // au nom d'expditeur le plus proche
                        nbdiff = simexped (bufFrom, listexped, sz_listexped);

                        // s'il y a des diffrences, mais pas trop
                        if (nbdiff && nbdiff <= nbmaxdiff)
                        {
                            // demande de destruction du mail
                            sprintf (bufw, "DELE %d", numes);
                            env_pop (bufw);
                            lire_pop ();
                            supprimes ++;

                            // si utilisation d'un fichier trace
                            if (ftrace)
                                // mmoriser le mail supprim dans ce fichier
                                fprintf (ftrace, "%s %d %s\n",
                                                 datecour, nbdiff, bufFrom);
                        }
                        // sinon, conserver le mail
                        else
                            conserves ++;
                    }

                    // dition d'un rcapitulatif
                    // "\n%d messages conservs, %d supprims\n"
                    printf (message ("BILAN_FILTRAGE"), conserves, supprimes);
                }

                // se dconnecter proprement du serveur pop
                deconnect_pop ();

                // si des mails ont t supprims
                if (supprimes)
                    // attendre pour enregistrement correct des suppressions
                    // (vite problme si autre filtre appel juste aprs)
                    sleep (2);
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s [nbmaxdiff] [-t fichier_trace] fich_configuration"
        psyntaxe ("SYNT_SUPSIMEXP");

    return (0);
}
